/*********************************************************/
/* This program is developed based on sampleclient.      */
/* Soccer Agent(client) program. Ver 0.02                */
/* All rights reserved, Copyright FUJITSU LIMITED 1996.  */
/*********************************************************/

/*
 *  udp client program.
 */
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#include "client.h"

#define MAX_X 52.5
#define MAX_Y 34
#define PAREA_X 36
#define PAREA_Y 20

#define K_RANGE 1.80
#define T_RANGE 9

Socket init_connection(char* host, int port) ;
int    send_message(char* buf, Socket sock) ;
int    receive_message(char *buf, int size, Socket *sock) ;
void   message_loop(FILE* fpin, FILE* fpout, Socket sock) ;
void   close_connection(Socket sock) ;

void   recvinfo_analyze(char *buf);
void   send_manager(char *buf);


FILE *fopen(),*outfile;
int outfile_flg = 0;

int init_flag = -1;
int waitrecv = 0;
int game_sta = 0;
int kick_range_flg = 0;
int turn_flg = 0;
int my_p_know;
int near_f = 0;
int kick_flg = 0;


char t_name[8];
int  t_side_i; 
char t_side_c;
int  t_num = 0;
char playmode[20];
int  now_time;
int status = 0;

double my_x;
double my_y;
double abs_dir;
double d_dir;

char sendbuf[MAXMESG];
char tmpbuf[20];

struct POSITION_TAG1 {
    int x;
    int y;
}; 

struct POSITION_TAG1 init_position[12] = {
{0,0},{-51,0},{-40,9},{-40,-9},{-38,24},{-38,-24},
{-25,0},{-20,-22},{-20,22},{-10,0},{0,14},{0,-14}
};

struct POSITION_TAG2 {
    double x;
    double y;
}; 

struct POSITION_TAG2 obj_pojition[5][5] = {	/* ɽϡXY */
{{-52.5,  -34},{-44  ,  -27},{-52.5,    0},{-44  ,   27},{-52.5,   34}},
{{-36  ,  -27},{-36  ,  -20},{36   ,    0},{-36  ,   20},{-36  ,   27}},
{{0    ,  -34},{0    ,  -17},{  0  ,    0},{0    ,   17},{0    ,   34}},
{{36   ,  -27},{36   ,  -20},{36   ,    0},{36   ,   20},{36   ,   27}},
{{52.5 ,  -34},{44   ,  -27},{52.5 ,    0},{44   ,   27},{52.5  ,  34}},
};

struct POSITION_TAG2 b_posi[5];
struct POSITION_TAG2 my_posi[5];
int time_idx[5];
int p_idx = 4;


int view_info[12] = {1,1,2,2,2,2,2,2,2,1,2,2}; 

static char *referee_say[] = {
"before_kick_off",
"kick_off_l","kick_off_r",
"goal_l","goal_r",
"kick_in_l","kick_in_r",
"corner_kick_l","corner_kick_r",
"goal_kick_l","goal_kick_r",
"free_kick_l","free_kick_r",
"play_on",
"half_time","time_over","time_extended"
};

struct objinfo_tag {
    double distance;
    double direction;
    int vdirection;
};

/* my number domain is ball info */
struct objinfo_tag player[2][12];   /* x=0 friend,=1 enemy */

struct objinfo_tag spaceinfo[5][5];

struct objinfo_tag lineinfo[4];
int lineinfonum;

/* hear info */
int h_now_time;
double h_b_x,h_b_y;
struct objinfo_tag h_player[12];


double b_dis;
int ball_estimate_flg;



/*
 * UDP connection γ
 *
 *  :
 * host : host name ⤷ host  IP address
 * port : port ֹ
 * 
 *  :
 * error ȯ硢Socket.socketfd  -1 ֤
 * 
 */

Socket init_connection(char *host, int port)
{
    struct hostent 	*host_ent ;
    struct in_addr      *addr_ptr ;
    struct sockaddr_in	cli_addr ;
    int			sockfd, val ;
    Socket		sock ;

    sock.socketfd = -1 ;

    if((host_ent = (struct hostent *)gethostbyname(host)) == NULL) {
	/* Check if a numeric address */
	if(inet_addr(host) == -1){
	    return sock ;
	}
    }
    else{
	addr_ptr = (struct in_addr *) *host_ent->h_addr_list ;
	host = inet_ntoa(*addr_ptr) ;
    }


    /*
     *  Open UDP socket.
     */
    if( (sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0){
	return sock ;		/* Can't open socket. */
    }

    val = fcntl(sockfd, F_GETFL, 0) ;
    val |= O_NONBLOCK ;
    fcntl(sockfd, F_SETFL, val) ;

    /*
     *  Bind any local address.
     */
    bzero((char *) &cli_addr, sizeof(cli_addr)) ;
    cli_addr.sin_family		= AF_INET ;
    cli_addr.sin_addr.s_addr	= htonl(INADDR_ANY) ;
    cli_addr.sin_port		= htons(0) ;


    if(bind(sockfd, (struct sockaddr *) &cli_addr,
	    sizeof(cli_addr)) < 0){
	return sock ;		/* Can't bind local address */
    }
    

    /*
     *  Fill in the structure with the address of the server.
     */
    sock.socketfd = sockfd ;

    bzero((char *) &sock.serv_addr, sizeof(sock.serv_addr)) ;
    sock.serv_addr.sin_family		= AF_INET ;
    sock.serv_addr.sin_addr.s_addr	= inet_addr(host) ;
    sock.serv_addr.sin_port		= htons(port) ;

    return sock ;
}


/*
 * socket  message 
 *
 *  :
 * buf  : message 
 * sock : socket
 * 
 *  :
 * Ф˼Ԥ硢-1 ֤
 * 
 */

int send_message(char *buf, Socket sock)
{
    int n ;

    n = strlen(buf) ;
    if (outfile_flg)
	fprintf(outfile, "send %d : %s",
		ntohs(sock.serv_addr.sin_port),buf);
/*    else
	printf("send %d : %s",
	       ntohs(sock.serv_addr.sin_port),buf); */
 
    if( sendto(sock.socketfd, buf, n, 0,
	       (struct sockaddr *)&sock.serv_addr, sizeof(sock.serv_addr))
       != n )
	return (-1) ;
    else
	return 0 ;
}

/*
 * socket  message μ
 *
 *  :
 * buf  : message  buffer
 * size : sizeof(buf)
 * sock : socket
 * 
 *  :
 * ˼Ԥ硢-1 ֤
 * Ƥ̵硢 0 ֤
 * Ƥ硢 1 ֤
 * 
 */

int receive_message(char *buf, int size, Socket *sock)
{
    int			n,servlen ;
    struct sockaddr_in	serv_addr ;
    
    servlen = sizeof(serv_addr) ;
    n = recvfrom(sock->socketfd, buf, size, 0,
		 (struct sockaddr *)&serv_addr, &servlen);

    if(n < 0)
	if( n == -1 && errno == EWOULDBLOCK){
	    buf[0] = '\0' ;
	    return 0 ;
	}
	else
	    return (-1) ;
    else{
	if (outfile_flg)
	    fprintf(outfile, "recv %d : ", 
		    ntohs(serv_addr.sin_port)); 
	else
/*	    printf("recv %d : ", 
		   ntohs(serv_addr.sin_port));  not display */ 


	sock->serv_addr.sin_port = serv_addr.sin_port ;
	buf[n] = '\0' ;

	if(n == 0)
	    return 0 ;
	else
	    return 1 ;
    }
}



/*
 * messege 
 *
 *  :
 * fpin : (Ƥ socket ޤ)
 * fpout: (socket μƤޤ)
 * sock : socket
 * 
 */

void message_loop(FILE* fpin, FILE* fpout, Socket sock)
{
    fd_set	readfds ;
    int		in, max_fd, n ;
    char	buf[MAXMESG];

    in = fileno(fpin) ;

    while(1){
	FD_ZERO(&readfds) ;
	FD_SET(in, &readfds) ;
	FD_SET(sock.socketfd, &readfds) ;

	max_fd = ((in > sock.socketfd) ? in : sock.socketfd) + 1 ;

	if(FD_ISSET(in, &readfds)){
/*	    	    fgets(buf, MAXMESG, fpin) ;   */
	  
	    if (waitrecv == 0) { 
		send_manager(buf); 
		if(send_message(buf, sock) == -1)
		    break ;
	    }
	}

	if(FD_ISSET(sock.socketfd, &readfds)) {
	    n = receive_message(buf,MAXMESG, &sock) ;
	    if (n == -1)
		break ;
	    else if(n > 0)
		recvinfo_analyze(buf);
/*	    fputs(buf, fpout) ; */ 
	    fflush(stdout) ; 
	}
    }
}

/*
 * socket  close
 *
 *  :
 * sock : socket
 * 
 */

void close_connection(Socket sock)
{
    close(sock.socketfd) ;
}

/* for test */
#ifdef TEST
void main(int argc, char **argv)
{
    Socket sock ;
    char *server ;
    int port ;

    if (argc == 5) {
	strcpy(t_name,argv[1]) ;
	t_num = atoi(argv[2]);
	server = argv[3] ;
	port = atoi(argv[4]) ;
    } else if (argc == 4) {
	strcpy(t_name,argv[1]) ;
	if (isdigit((int)*argv[2])) {
	    t_num = atoi(argv[2]);
	    server = argv[3] ;
	} else {
	    server = argv[2] ;
	    port = atoi(argv[3]) ;
	}
    } else if (argc == 3) {
	strcpy(t_name,argv[1]) ;
	if (isdigit((int)*argv[2])) {
	    t_num = atoi(argv[2]);
	    server = "localhost" ;
	} else
	    server = argv[2] ;
	port = 6000 ;
    } else if (argc == 2) {
	strcpy(t_name,argv[1]) ;
	server = "localhost" ;
	port = 6000 ;
    } else {
	strcpy(t_name,"sekine") ;
	server = "localhost" ;
	port = 6000 ;
    }

    sock = init_connection(server,port) ;
    if(sock.socketfd == -1)
	exit(1) ;

    message_loop(stdin, stdout, sock) ;

    close_connection(sock) ;
    fclose(outfile);
}
#endif /* TEST */

int word_create(char *p , char *tmpbuf)
{
    int i,exit_flg=0;
    char *tmpbuf_ptr;
  
    tmpbuf_ptr = tmpbuf;

    for (i=0; *p != '\0' , ~exit_flg;i++) {
	switch (*p) {
	case ' ':
	case ')':
	case '(':
	    *tmpbuf_ptr  = '\0'; 
	    p++;
	    exit_flg = ~exit_flg;
	    break;
	default:
	    *tmpbuf_ptr++ = *p++;
	    break;
	}
    }
    return i;
}

void r_init(char *p)
{

    if (*p == 'l') 
	t_side_i = 1;
    else if (*p == 'r')
	t_side_i = -1;
    else
	exit(10100);

    t_side_c = *p;

    ++p;
    ++p;

    p += word_create(p ,tmpbuf);
    t_num = atoi(tmpbuf); 

    word_create(p ,tmpbuf);
    strcpy(playmode,tmpbuf);

    switch (playmode[0]) { 
    case 'b':			/* before_kick_off */
	switch (view_info[t_num]) {
	case 1:
	    sprintf (sendbuf,"(change_view normal high)\n");
	    break;
	case 2:
	    sprintf (sendbuf,"(change_view narrow high)\n");
	    break;
	}

	break;
    case 'k':			/* kick_off        */
    case 'p':			/* play_on         */
	game_sta = 1;
	break;
    case 't':			/* throw_in        */
    case 'c':			/* corner_kick     */
    case 'g':			/* goal_kick       */
    }

    /*  if ((outfile = fopen(sprintf(tmpbuf,"log_%c_%d.txt",
	t_side_c,t_num) , "w")) == NULL) {
	printf("can't open writefile log_%c_%d.txt\n",t_side_c,t_num);
	exit(20000);
	}
	outfile_flg = 1;
	*/

}

void r_reconnect(char *p)
{

    if (*p == 'l') 
	t_side_i = 1;
    else if (*p == 'r')
	t_side_i = -1;
    else
	exit(10100);

    t_side_c = *p;

    ++p;
    ++p;

    word_create(p ,tmpbuf);
    strcpy(playmode,tmpbuf);

    switch (playmode[0]) { 
    case 'b':			/* before_kick_off */
	switch (view_info[t_num]) {
	case 1:
	    sprintf (sendbuf,"(change_view normal high)\n");
	    break;
	case 2:
	    sprintf (sendbuf,"(change_view narrow high)\n");
	    break;
	}

	break;
    case 'k':			/* kick_off        */
    case 'p':			/* play_on         */
	game_sta = 1;
	break;
    case 't':			/* throw_in        */
    case 'c':			/* corner_kick     */
    case 'g':			/* goal_kick       */
    }

    /*  if ((outfile = fopen(sprintf(tmpbuf,"log_%c_%d.txt",
	t_side_c,t_num) , "w")) == NULL) {
	printf("can't open writefile log_%c_%d.txt\n",t_side_c,t_num);
	exit(20000);
	}
	outfile_flg = 1;
	*/

}

void r_see(char *p)
{
    int i;
    int x,y;
  
    char direction[20];

    waitrecv = 0;

    for (x=0;x<5;x++) {
	for (y=0;y<5;y++) {
	    if (turn_flg == 0) { 
		spaceinfo[x][y].distance = -1;  
	    }
	    spaceinfo[x][y].vdirection = 1;
      	
	}
    }
    for (x=0;x<2;x++) {
	for (y=0;y<12;y++) {
	    player[x][y].distance = -1;  
	}
    }
    for (x=0;x<4;x++) {
	lineinfo[x].distance = -1;  
    }
    lineinfonum = -1;

    p += word_create(p ,tmpbuf);
    now_time = atoi(tmpbuf);

    while (*p != '\n') {
	p++;
	if (*p == '(') {	/* start ObjInfo */
	    ++p;
	    switch (*p) {
	    case 'g':		/* goal */
		p+=5;
		if (*p == t_side_c) {
		    x = 0;
		} else {
		    x = 4;
		}

		p+=3;
		p += word_create(p ,tmpbuf);
		spaceinfo[x][2].distance = atof(tmpbuf);
        
		p += word_create(p ,tmpbuf);
		spaceinfo[x][2].direction = atof(tmpbuf);
        
		spaceinfo[x][2].vdirection = 0;	/* get new info */

		++p;
		break;
	    case 'b':		/* ball */
		p+=6;

		p += word_create(p ,tmpbuf);
		player[0][t_num].distance = atof(tmpbuf);
        
		p += word_create(p ,tmpbuf);
		player[0][t_num].direction = atof(tmpbuf);
        
		if (*p == ' ') {
		    player[0][t_num].vdirection = 1000;
		} else {
		    p += word_create(p ,tmpbuf);
		    player[0][t_num].vdirection = atoi(tmpbuf);
		}      
		++p;
		break;

	    case 'p':		/* player */
		p+=6;

		if (*p == ')' ) { /* lost Teamname */
		    for (;  *p!='\n'; ++p)
			if (*p == '(') break;
		    break;
		}
        
		++p;
	
		p += word_create(p ,tmpbuf);
		if (strcmp(tmpbuf,t_name) == 0)
		    x = 0;	/* friendplayer */
		else 
		    x = 1;	/* enemyplayer */


		if (*p == ' ') { /* lost uniform number */
		    for (i = 1; i < 12; i++) {
			if (player[x][i].distance < 0 && (x!=0 || i!=t_num)){
			    y = i;
			    break;
			}
		    }
		} else {
		    p += word_create(p ,tmpbuf);
		    y =  atoi(tmpbuf);

		    if (player[x][y].distance >= 0) { 
			for (i = 1; i < 12; i++) {
			    if (player[x][i].distance < 0
				&& (x!=0 || i!=t_num) && (i != y)) {
				player[x][i].distance = player[x][y].distance; 
				player[x][i].direction = player[x][y].direction;
				player[x][i].vdirection = player[x][y].vdirection;
				break;
			    }
			}
		    }
		}

		++p;

		p += word_create(p ,tmpbuf);
		player[x][y].distance = atof(tmpbuf);

		p += word_create(p ,tmpbuf);
		player[x][y].direction = atof(tmpbuf);

		if (*p == ' ') {
		    player[x][y].vdirection = 1000;
		} else {
		    p += word_create(p ,tmpbuf);
		    player[x][y].vdirection = atoi(tmpbuf);
		}      

		++p;
		break;
	    case 'f':			/* flag */
		p+=5;

		switch (*p) {
		case 'p':
		    p+=2;
		    if (*p == t_side_c)
			x = 1;
		    else
			x = 3;

		    p+=2;
		    switch (*p) {
		    case 't':
			if (t_side_c == 'l')
			    y = 1;
			else
			    y = 3;
			break;
		    case 'c':
			y = 2;
			break;
		    case 'b':
			if (t_side_c == 'l')
			    y = 3;
			else
			    y = 1;
			break;
		    }
		    break;
		case 'l':
		case 'r':
		    if (*p == t_side_c)
			x = 0;
		    else
			x = 4;

		    p+=2;
		    if ((*p == 't' && t_side_c == 'l') ||
			(*p == 'b' && t_side_c == 'r'))
			y = 0;
		    else
			y = 4;
		    break;
		case 'c':
		    x = 2;

		    p+=2;
		    if ((*p == 't' && t_side_c == 'l') ||
			(*p == 'b' && t_side_c == 'r'))
			y = 0;
		    else
			y = 4;
		    break;
		}
        
		p+=3;
		p += word_create(p ,tmpbuf);
		spaceinfo[x][y].distance = atof(tmpbuf);
        
		p += word_create(p ,tmpbuf);
		spaceinfo[x][y].direction = atof(tmpbuf);
        
		spaceinfo[x][y].vdirection = 0;	/* get new info */

		++p;
		break;

	    case 'l':		/* line info */
		p+=5;
		switch (*p) {
		case 'l':
		case 'r':
		    if (*p == t_side_c)
			x=0;
		    else 
			x=1;
		    break;
		case 't':
		case 'b':
		    if ((*p == 't' && t_side_c == 'l') ||
			(*p == 'b' && t_side_c == 'r'))
			x = 2;
		    else
			x = 3;
		    break;
		}

		lineinfonum = x;
		p+=3;
		p += word_create(p ,tmpbuf);
		lineinfo[x].distance = atof(tmpbuf);
        
		p += word_create(p ,tmpbuf);
		lineinfo[x].direction = atof(tmpbuf);
        
		lineinfo[x].vdirection = 0;	/* get new info */

		++p;
		break;
	    }
	}

    }

    for (x=0;x<5;x++) {
	for (y=0;y<5;y++) {
	    if (spaceinfo[x][y].direction < 0)  
		spaceinfo[x][y].direction = spaceinfo[x][y].direction - 0.5;  
	    else
		spaceinfo[x][y].direction = spaceinfo[x][y].direction + 0.5;  
	}
    }
    for (x=0;x<2;x++) {
	for (y=0;y<12;y++) {
	    if (player[x][y].direction < 0)  
		player[x][y].direction = player[x][y].direction - 0.5;  
	    else
		player[x][y].direction = player[x][y].direction + 0.5;  
	}
    }
    if (lineinfonum != -1) {
	if (fabs(lineinfo[lineinfonum].direction) != 90)
	    if (lineinfo[lineinfonum].direction < 0)
		lineinfo[lineinfonum].direction = lineinfo[lineinfonum].direction - 0.5;  
	    else
		lineinfo[lineinfonum].direction = lineinfo[lineinfonum].direction + 0.5;  
    }




    /* amendment from turn command */ 
    if (turn_flg == 0) { 
	for (x=0;x<5;x++) {
	    for (y=0;y<5;y++) {
		if (spaceinfo[x][y].distance > 0 && spaceinfo[x][y].vdirection) {
		    i = spaceinfo[x][y].direction - turn_flg;
		    if (i < -180)  
			spaceinfo[x][y].direction = 360 + i;
		    else 
			if (i > 180)
			    spaceinfo[x][y].direction = -360 + i;
			else
			    spaceinfo[x][y].direction = i;
		}	
	    }
	}
    }

    my_p_know = my_position();
}

/* see ̵ν */
/*******************
  my_position()
*****************************/
int  my_position()
{
    int i,x,y,tx,ty;
    double obj_dis,obj_x,obj_y,linedis,mygoal_dir,engoal_dir,tmp_x,tmp_y;
    double ldirection;
    double o_dir;
    int p_or_m;

    if (lineinfonum == -1) return 3;

    ldirection = lineinfo[lineinfonum].direction;
    linedis = lineinfo[lineinfonum].distance * sin(fabs(ldirection) / 180.0 * M_PI);
 
    tmp_x = 1000;                /* improbable MAX value */
    tmp_y = 1000;                /* improbable MAX value */
    obj_dis = 1000;		/* improbable MAX value */
    switch (lineinfonum) {
    case 0:
                                            /* abs_direction */
	if (lineinfo[0].direction < 0) 
	    abs_dir = 90 - lineinfo[0].direction; 
	else
	    abs_dir = - 90 - lineinfo[0].direction; 
                                            /* (x y)position */
	tmp_x = - MAX_X + linedis;
	break;
    case 1:
                                            /* abs_direction */
	if (lineinfo[1].direction < 0) 
	    abs_dir = - 90 - lineinfo[1].direction; 
	else
	    abs_dir = 90 - lineinfo[1].direction; 
                                            /* (x y)position */
        tmp_x = MAX_X - linedis;
	break;
    case 2:
                                            /* abs_direction */
	if (lineinfo[2].direction < 0) 
	    abs_dir = - 180 - lineinfo[2].direction; 
	else
	    abs_dir = 0 - lineinfo[2].direction; 
	                                    /* (x y)position */
        tmp_y = - MAX_Y + linedis;
	break;
    case 3:
	                                    /* abs_direction */
	if (lineinfo[3].direction < 0) 
	    abs_dir = 0 - lineinfo[3].direction; 
	else
	    abs_dir = 180 - lineinfo[3].direction; 
	                                    /* (x y)position */
        tmp_y = MAX_Y - linedis;
	break;
    }
    
    for (tx=0;tx<5;tx++) {
	for (ty=0;ty<5;ty++) {
	    if (spaceinfo[tx][ty].distance >= 0 &&
		spaceinfo[tx][ty].vdirection == 0 &&
		spaceinfo[tx][ty].distance < obj_dis) {
		x=tx;
		y=ty;
		obj_dis = spaceinfo[tx][ty].distance;  
	    }
	}
    }

    if (obj_dis == 1000) 		     /* no looking for object */
	if (tmp_x != 1000) { 
	    my_x = tmp_x;
	    return 1;
        } else {
	    my_y = tmp_y;
	    return 2;
	}


    switch (x) {
    case 0:
	obj_x = - MAX_X;
        break;
    case 1:
	obj_x = - PAREA_X;
        break;
    case 2:
        obj_x = 0;
        break;
    case 3:
 	obj_x = PAREA_X;
        break;
    case 4:
	obj_x = MAX_X;
        break;
    }
    switch (y) {
    case 0:
	obj_y = - MAX_Y;
        break;
    case 1:
	obj_y = - PAREA_Y;
        break;
    case 2:
        obj_y = 0;
        break;
    case 3:
 	obj_y = PAREA_Y;
        break;
    case 4:
	obj_y = MAX_Y;
        break;
    }

    o_dir = abs_dir + spaceinfo[x][y].direction; 
    if (o_dir < -180)  
	o_dir =  360 + o_dir;
    else 
	if (o_dir > 180)
	    o_dir = -360 + o_dir;
    

    my_x = obj_dis * cos(o_dir / 180.0 * M_PI);
    my_y = obj_dis * sin(o_dir / 180.0 * M_PI);
    
    my_x = obj_x - my_x;
    my_y = obj_y - my_y;

/* ǡǼ */
    if (player[0][t_num].distance < 0) { 
/*	printf ("%5d not ball !!\n",now_time); */
	return 0;
	obj_x = 1000;
	obj_y = 1000;
    } else { 
	o_dir  = player[0][t_num].direction + abs_dir;
	if (o_dir < -180)
	    o_dir =  360 + o_dir;
	else 
	    if (o_dir > 180)
		o_dir = -360 + o_dir;
	obj_x = my_x + player[0][t_num].distance * cos(o_dir / 180.0 * M_PI);
	obj_y = my_y + player[0][t_num].distance * sin(o_dir / 180.0 * M_PI);
/*	printf ("%5d %4.1lf %4.1lf\n",now_time,obj_x,obj_y); */
	printf ("%4.1lf %4.1lf\n",obj_x,obj_y); 
    }
    

    if (p_idx == 4) 
	p_idx = 0;
    else
	p_idx++;

    my_posi[p_idx].x = my_x;
    my_posi[p_idx].y = my_y;
    b_posi[p_idx].x = obj_x; 
    b_posi[p_idx].y = obj_y;
    time_idx[p_idx] = now_time;

    return 0;          
}

void r_hear(char *p)
{
    int  i;
    char direction[10];
    char h_side,h_cmd;
    int	 h_num;
    double h_x,h_y,h_dis;


    p += word_create(p ,tmpbuf);
    now_time = atoi(tmpbuf);

    p += word_create(p ,tmpbuf);
    strcpy(direction,tmpbuf);
    switch (direction[0]) {
    case 'r':			/* refree say */
	word_create(p ,tmpbuf);
	for (i = 0; i < 17;i++) 
	    if (strncmp(tmpbuf,referee_say[i],strlen(referee_say[i])) == 0) break;
	switch (i) {
	case 1:
	    if (t_side_i == 1) game_sta = 1; /* start_game */
	    break;
	case 2:
	    if (t_side_i == -1) game_sta = 1; /* start_game */
	    break;
	case 3:			/* goal */
	    if (t_side_i == 1) 
		if (t_num > 2) game_sta = 2; /* return home position */
	    printf ("\n\n");
	    break;
	case 4:			/* goal */
	    if (t_side_i == -1) 
		if (t_num > 2) game_sta = 2; /* return home position */
	    printf ("\n\n");
	    break;
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
        case 10:
        case 11:
        case 12:
	case 13:		/* play_on */
	    game_sta = 1;
	    break;
	case 14:		/* harf_time */
	case 16:		/* time_extended */
	    game_sta = -1;
	    break;
        case 15:		/* time_over */
            exit(0);
            break;
	}
	break;
    case 's':			/* (my)self say */
	break;
    default:
	sscanf(p,"%c%2d%c %lf %lf %lf",&h_side,&h_num,&h_cmd,&h_x,&h_y,&h_dis); 

	if (h_side != t_side_c)
	    break;
	
/* ǡ */
	switch (h_cmd) {
	case 'e':
        case 'b':
	    h_now_time = now_time;
	    h_b_x = h_x;
	    h_b_y = h_y;

	    h_player[h_num].distance = h_dis;
	    h_player[h_num].direction = atof(direction);
	    h_player[h_num].vdirection = now_time;
	    break;
	}
	

        break;
    }
}



void recvinfo_analyze(char *buf)
{
    char *p;
      
    p = buf;
    p++;
  
    switch (*p) {
    case 'i':			/* init command */   
	p = p + 5;		/* for side info */
	r_init(p);
	break;
    case 'e':			/* error command */
	p = p + 6;		/* for reason info */
	/*    r_error(p); */
	break;
    case 'r':			/* reconnect command */
	p = p + 10;		/* for side info */
	r_reconnect(p);
	break;
    case 's':			/* see command */
	p = p + 4;		/* for time info */
	r_see(p);
	break;
    case 'h':			/* hear command */
	p = p + 5;		/* for time info */
	r_hear(p);      
	break;
    defult:			/* error data (server bug?) */
	exit (10000);
    }
}

/* ;дؿ */
double cos_theorem(double dis1,double dis2,double dir1,double dir2) {
    return(sqrt((dis1*dis1)+(dis2*dis2)-2*dis1*dis2*cos(fabs(dir1-dir2)/180.0*M_PI)));  
}

/* ܡͽ¬롼 */
int ball_estimate(double *o_dis,double *o_dir,double *obj_x,double *obj_y) {
    double  tmp_x,tmp_y,coefficient;
    int p_i1,p_i2;
    int	time_diff;

    if (player[0][t_num].distance >= 0 && player[0][t_num].distance < 3.3)
	return 1;

    p_i1 = p_idx; 
    if (p_i1 == 0) 
	p_i2 = 4;
    else 
	p_i2 = p_i1 - 1;

    if (view_info[t_num] == 1) {
	time_diff = 6;
        coefficient = 2;
    } else {
	time_diff = 3;
        coefficient = 2.6;
    }

    if ((now_time != time_idx[p_i1]) || ((now_time - time_idx[p_i2]) > time_diff)) 
	return 1;
    if (fabs((b_posi[p_i2].y - b_posi[p_i1].y)/(b_posi[p_i2].x - b_posi[p_i1].x) -  
	     (b_posi[p_i1].y - my_y)/(b_posi[p_i1].x - my_x)) < 0.2) 
	return 1;

    tmp_x = b_posi[p_i1].x - (b_posi[p_i2].x - b_posi[p_i1].x) * coefficient;
    if (tmp_x < -51.5) {
	tmp_x = -51.5;    
	coefficient = (-51 - b_posi[p_i1].x) / (b_posi[p_i2].x - b_posi[p_i1].x) * -1;
    }
    tmp_y = b_posi[p_i1].y - (b_posi[p_i2].y - b_posi[p_i1].y) * coefficient;

    *o_dir = atan2(tmp_y - my_y,tmp_x - my_x); 
    *o_dis = (tmp_x - my_x) / cos(*o_dir);

    *o_dir = (*o_dir * 180.0 / M_PI) - abs_dir;
	   
    if (*o_dir < -180)  
	*o_dir =  360 + *o_dir;
    else 
	if (*o_dir > 180)
	    *o_dir = -360 + *o_dir;
	
    if (*o_dis < 2) return 1;
    if (fabs(*o_dir) < 16 && *o_dis > 10) return 2;   
    if (fabs(*o_dir) < 9 || fabs(*o_dir) > 175) return 1;   

    *obj_x = tmp_x;
    *obj_y = tmp_y;
    return 0;
}

/* turn ¹ԥ롼 */
void turn_cmd_i(char *buf,int o_dir,long log) {
    sprintf (buf,"(turn %d)\n",o_dir);
/*    printf ("log = %6ld\n",log); */
    kick_flg = 0;
}
void turn_cmd_d(char *buf,double o_dir,long log) {
    sprintf (buf,"(turn %4.0f)\n",o_dir);
/*    printf ("log = %6ld\n",log); */
    kick_flg = 0;
}
/* dash ¹ԥ롼 */
void dash_cmd_d(char *buf,double o_dis,long log) {
    int x,y;
    near_f = 0;
    for (x=0;x<2;x++) {
	for (y=0;y<12;y++) {
	    if ((player[x][y].distance >= 0 && player[x][y].distance < 2) && (x!=0 || y!=t_num)) {
		status = 3;
		sprintf (buf,"(turn 90)\n");
		return;
	    }
	}
    }
    sprintf (buf,"(dash %3.1lf)\n",o_dis);
/*    printf ("log = %6ld\n",log); */
    kick_flg = 0;
}

/* kick ¹ԥ롼 */
void kick_cmd_d(char *buf,double o_dis,double o_dir,long log) {
    sprintf (buf,"(kick %3.1lf %4.0f)\n",o_dis,o_dir);
/*    printf ("log = %6ld\n",log); */
    kick_flg = 1;
}
void kick_cmd_i(char *buf,double o_dis,int o_dir,long log) {
    sprintf (buf,"(kick %3.1lf %d)\n",o_dis,o_dir);
/*    printf ("log = %6ld\n",log); */
    kick_flg = 1;
}
/* say ¹ԥ롼 */
int say_estimate(double *tmp_x,double *tmp_y) {
    double  coefficient;
    int p_i1,p_i2;
    int	time_diff;

    p_i1 = p_idx; 
    if (p_i1 == 0) 
	p_i2 = 4;
    else 
	p_i2 = p_i1 - 1;

    if (view_info[t_num] == 1) {
	time_diff = 6;
/*        coefficient = 0.81537; */
        coefficient = 0.75; 
    } else {
	time_diff = 3;
/*        coefficient = 0.88474; */
        coefficient = 0.8; 
    }

    if ((now_time != time_idx[p_i1]) || ((now_time - time_idx[p_i2]) > time_diff)) 
	return 1;

    *tmp_x = b_posi[p_i1].x - (b_posi[p_i2].x - b_posi[p_i1].x) * coefficient;
    if (*tmp_x < -51.5) {
	*tmp_x = -51.5;    
	coefficient = (-51 - b_posi[p_i1].x) / (b_posi[p_i2].x - b_posi[p_i1].x) * -1;
    }
    *tmp_y = b_posi[p_i1].y - (b_posi[p_i2].y - b_posi[p_i1].y) * coefficient;
    return 0;
}


void say_cmd_d(char *buf,long log) {
    double tmp_x,tmp_y;

    if (say_estimate(&tmp_x,&tmp_y) == 0) {
	sprintf (buf,"(say %c%2de %3.1lf %3.1lf %3.1lf)\n"
		 ,t_side_c,t_num,tmp_x,tmp_y,player[0][t_num].distance);
    } else { 
	sprintf (buf,"(say %c%2db %3.1lf %3.1lf %3.1lf)\n"
		 ,t_side_c,t_num,b_posi[p_idx].x,b_posi[p_idx].y,player[0][t_num].distance);
    } 
/*    printf ("log = %6ld\n",log); */
    kick_flg = 0;
}

double shoot_direction() {
    double  o_dir;
    int j;
    if (spaceinfo[4][2].distance < 0) {  /* lost object info */
	o_dir = atan2(obj_pojition[4][2].y - my_y + ((rand() % 3 - 1) * 4),
		      obj_pojition[4][2].x - my_x)
	              * 180.0 / M_PI; 
	o_dir = o_dir - abs_dir;
	if (o_dir < -180)  
	    o_dir =  360 + o_dir;
	else 
	    if (o_dir > 180)
		o_dir = -360 + o_dir;
	return o_dir;
    } else {
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && 
		fabs(player[1][j].direction - spaceinfo[4][2].direction) < 5)
		break;
        }
        if (j == 12) {
	    o_dir = spaceinfo[4][2].direction;
            return o_dir;
	}

	o_dir = atan2(obj_pojition[4][2].y - my_y + 4,
	              obj_pojition[4][2].x - my_x)
	              * 180.0 / M_PI; 
        o_dir = o_dir - abs_dir;
        for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && 
		fabs(player[1][j].direction - o_dir) < 5)
		break;
	}
        if (j == 12) {
            return o_dir;
	}

        o_dir = atan2(obj_pojition[4][2].y - my_y - 4,
                      obj_pojition[4][2].x - my_x)
		      * 180.0 / M_PI; 
 	o_dir = o_dir - abs_dir;
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && 
		    fabs(player[1][j].direction - o_dir) < 5)
		    break;
	}
        if (j == 12) {
            return o_dir;
	}

	o_dir = atan2(obj_pojition[4][2].y - my_y + ((rand() % 3 - 1) * 4),
		      obj_pojition[4][2].x - my_x)
	              * 180.0 / M_PI; 
	o_dir = o_dir - abs_dir;
        return o_dir;
    }
}

double through_pass(char *buf) {
    double  o_dir,o_dis;
    int j;

    if (my_y > 0)
	j = -3;
    else
	j = 3;

    o_dir = atan2(0 - my_y + j,36 - my_x); 
    o_dis = (36 - my_x) / cos(o_dir);
    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
    if (o_dir < -180)  
	o_dir =  360 + o_dir;
    else 
	if (o_dir > 180)
	    o_dir = -360 + o_dir;

    kick_cmd_d(buf,o_dis * 2.5,o_dir,20040);
}

int near_ball() {
    if (near_f == 0) {
	near_f = 1;
	return -40;
    } 
    return 80;
}

double ch_dir(double o_dir) {
    if (o_dir < -180)  
	o_dir =  360 + o_dir;
    else 
	if (o_dir > 180)
	    o_dir = -360 + o_dir;
    return o_dir;
}

/*************************************************************
    goal_keeper manager
**************************************************************/
void gk_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }
    if (fabs(abs_dir) < 90) {
	pass_ok = 0;
        for (i=4;i<12;i++) {
	    if (player[0][i].distance > 25) {
                pass_ok = 1;
                for (j=1;j<12;j++) { 
		    if (player[1][j].distance >= 0)  
                        if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
                                        player[0][i].direction,player[1][j].direction) < 4 ||
                            (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
                             player[0][i].distance > player[1][j].distance )) &&
			     fabs(ch_dir(player[0][i].direction + abs_dir)) < 80) 

                            pass_ok = 0;
                }
            }
            if (pass_ok) break;
        }

        if (i<12) 
             kick_cmd_d(buf,player[0][i].distance*3,player[0][i].direction,20040);
	else {
	    for (i = 11;i > 6;i--) {
		if (now_time - 4 < h_player[i].vdirection && 
		    fabs(ch_dir(h_player[i].direction + abs_dir)) < 70 &&
		    h_player[i].distance > 24 && h_player[i].distance < 35)
		    break;
	    }

	    if (i != 6) {
		kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
	    } else {
		if (my_y < 0) {
		    if (spaceinfo[3][1].distance < 0) {  /* lost object info */
			o_dir = atan2(obj_pojition[3][1].y - my_y,obj_pojition[3][1].x - my_x)
			          * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    } else {
			o_dir = spaceinfo[3][1].direction;
		    }
		} else {
		    if (spaceinfo[3][3].distance < 0) {  /* lost object info */
			o_dir = atan2(obj_pojition[3][3].y - my_y,obj_pojition[3][3].x - my_x)
		                  * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    } else {
			o_dir = spaceinfo[3][3].direction;
		    }
		}
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

	        kick_cmd_d(buf,100,o_dir,10030);
	    }
	}
    } else {	
        for (i = 11;i > 6;i--) {
            if (now_time - 4 < h_player[i].vdirection && 
		fabs(ch_dir(h_player[i].direction + abs_dir)) < 60 && 
		h_player[i].distance > 24 && h_player[i].distance < 35)
                break;
        }

        if (i != 6) {
            kick_cmd_d(buf,h_player[i].distance * 3,h_player[i].direction,50055);
        } else {
            o_dir = shoot_direction();
            kick_cmd_d(buf,100,o_dir,50060);
        }
    }
    kick_range_flg = 0;
} 

void gk_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis,me_goal_dis;
    int p_i1,p_i2;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (now_time - 5 > h_now_time)
		turn_cmd_i(buf,90,10010);	/* looking for ball */
	    else {
		o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
                o_dir = o_dir - abs_dir;
	        if (o_dir < -180)  
		    o_dir =  360 + o_dir;
	        else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;
		turn_cmd_d(buf,o_dir,10020);	/* looking for ball */
	    }
	} else {
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		gk_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction;
		obj_x = my_x + player[0][t_num].distance * cos(o_dir / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir / 180.0 * M_PI); 
 		o_dis = player[0][t_num].distance;

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 
		if (obj_x < -34 && fabs(obj_y) < 18) {
		    if (ball_estimate_flg == 0) {
                        turn_cmd_d(buf,o_dir,10040);
			b_dis = o_dis;
			status = 2;
		    } else if (ball_estimate_flg = 1) { 
			if (player[0][t_num].direction < -T_RANGE || 
			    player[0][t_num].direction > T_RANGE) 
			    turn_cmd_d(buf,player[0][t_num].direction,10050);
			else    
			    dash_cmd_d(buf,player[0][t_num].distance * 30,10060); 
		    } else {
			dash_cmd_d(buf,player[0][t_num].distance * 30,10080); 
		    }
		} else {
		    if (obj_x < -25) {
			say_cmd_d(buf,10090);
		    } else {
			if (fabs(my_y-init_position[t_num].y) > 3 ||
			    fabs(my_x-init_position[t_num].x) > 3) {
			    o_dir = atan2(init_position[t_num].y - my_y,
					  init_position[t_num].x - my_x)
				           * 180.0 / M_PI; 
			    o_dir = o_dir - abs_dir;
		    
			    if (o_dir < -180)  
				o_dir =  360 + o_dir;
			    else 
				if (o_dir > 180)
				    o_dir = -360 + o_dir;
			    turn_cmd_d(buf,o_dir,10100); 
			    status = 1;
			} else {
			    say_cmd_d(buf,10110);
		        }
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                gk_kick(buf);
                status = 0;
                return;
        }
	if (time_idx[p_idx] < now_time - 25) {
		turn_cmd_d(buf,80,20155); 
		status = 0;
	        return;
        } 
	if (fabs(my_y-init_position[t_num].y) > 3 ||
	    fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,10120); 
	    else
                dash_cmd_d(buf,o_dis * 30,10130);
	} else {
	    turn_cmd_d(buf,-abs_dir,10140);
	    status = 0;
	    
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                gk_kick(buf);
                status = 0;
                return;
        }
        if (b_dis > 9.999 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis * 33,10150);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,10160);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                gk_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,10180);
	status = 0;
    }
}

/*************************************************************
    DF-stoper manager
**************************************************************/
void dfs_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }
    if (fabs(abs_dir) < 90) {
	pass_ok = 0;
	for (i=4;i<12;i++) {
	    if (player[0][i].distance > 20) {
		pass_ok = 1;
		for (j=1;j<12;j++) { 
		    if (player[1][j].distance >= 0)  
			if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
					player[0][i].direction,player[1][j].direction) < 4 ||
			    (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
			     player[0][i].distance > player[1][j].distance )) &&
			     fabs(ch_dir(player[0][i].direction + abs_dir)) < 80) 
			    pass_ok = 0;
		}
	    }
	    if (pass_ok) break;
	}

	if (i<12) 
	    kick_cmd_d(buf,player[0][i].distance*2.5,player[0][i].direction,20040);
	else {
	    for (i = 11;i > 6;i--) {
		if (now_time - 3 < h_player[i].vdirection && 
		    fabs(ch_dir(h_player[i].direction + abs_dir)) < 70 &&
		    h_player[i].distance > 18 && h_player[i].distance < 35)
		    break;
	    }

	    if (i != 6) {
		kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
	    } else {
		j = rand() % 5;
		o_dir = atan2(obj_pojition[3][j].y - my_y,obj_pojition[3][j].x - my_x)
			* 180.0 / M_PI; 
		o_dir = o_dir - abs_dir;
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		kick_cmd_d(buf,100,o_dir,20050);
	    }
	}
    } else {
	for (i = 11;i > 6;i--) {
	    if (now_time - 3 < h_player[i].vdirection && 
		fabs(ch_dir(h_player[i].direction + abs_dir)) < 70 &&
		h_player[i].distance > 18 && h_player[i].distance < 35)
		break;
	}

	if (i != 6) {
	    kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
	} else {
	    j = rand() % 5;
	    o_dir = atan2(obj_pojition[3][j].y - my_y,obj_pojition[3][j].x - my_x)
		* 180.0 / M_PI; 
	    o_dir = o_dir - abs_dir;
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;

	    kick_cmd_d(buf,100,o_dir,20060);
	}
    }
    kick_range_flg = 0;
}

void dfs_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (now_time - 5 > h_now_time)
		turn_cmd_i(buf,near_ball(),20010);
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */
		    o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    if (fabs(o_dir) < 22) 
			turn_cmd_i(buf,near_ball(),20025);
		    else
			turn_cmd_d(buf,o_dir,20020);  /* looking for ball */
/*		} else {
		    turn_cmd_i(buf,near_ball(),20030);
		} */
	    }
	} else {
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		dfs_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

 		o_dis = player[0][t_num].distance;

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 

		if (obj_x < -25 && (((t_num % 2) == 0 && obj_y > -2) || ((t_num % 2) == 1 && obj_y < 2)))
		    if (o_dis < 12) {
			if (ball_estimate_flg == 0) {
			    turn_cmd_d(buf,o_dir,20070);
			    b_dis = o_dis;
			    status = 2;
			} else if (ball_estimate_flg = 1) { 
			    if (player[0][t_num].direction < -T_RANGE || 
				player[0][t_num].direction > T_RANGE) 
				turn_cmd_d(buf,player[0][t_num].direction,20080); 
			    else    
				dash_cmd_d(buf,player[0][t_num].distance*30,20090); 
			} else {
			    dash_cmd_d(buf,player[0][t_num].distance*30,20110); 
			}
		    } else
			if (player[0][t_num].direction < -T_RANGE || 
			    player[0][t_num].direction > T_RANGE) 
			    turn_cmd_d(buf,player[0][t_num].direction,20120); 
			else    
			    dash_cmd_d(buf,(player[0][t_num].distance-12.1)*30,20130);
		else {
		    if (fabs(my_y-init_position[t_num].y) > 3 ||
			fabs(my_x-init_position[t_num].x) > 3) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x)
			              * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;

			turn_cmd_d(buf,o_dir,20140);
			status = 1;
		    } else {
			say_cmd_d(buf,20150);
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                dfs_kick(buf);
                status = 0;
                return;
        }
	if (time_idx[p_idx] < now_time - 15) {
		turn_cmd_d(buf,80,20155); 
		status = 0;
	        return;
        } 

	if (fabs(my_y-init_position[t_num].y) > 3 || fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,20160); 
	    else
                dash_cmd_d(buf,o_dis * 30,20170);

	} else {
	    turn_cmd_d(buf,-abs_dir,20180);
	    status = 0;
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                dfs_kick(buf);
                status = 0;
                return;
        }
        if (b_dis > 6.666 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis*33,20190);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,20200);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                dfs_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,20220);
	status = 0;
    }
}

/*************************************************************
    Defensive - half manager
**************************************************************/
void def_half_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int rnd_idx;
    int pass_ok,i,j,o_dir_i;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }

    if (fabs(abs_dir) < 120) {
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && player[1][j].distance < 10)
		break;
        }
	if (j == 12 && my_x < 0) {		/* ɥ֥ */
	    if (rand() % 7 != 0) {
		o_dir = atan2(obj_pojition[4][2].y - my_y,
			      obj_pojition[4][2].x - my_x)
			      * 180.0 / M_PI; 
		o_dir = o_dir - abs_dir;
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		kick_cmd_d(buf,9+rand()%3,o_dir,50035);
		d_dir = o_dir;
	    } else {
		through_pass(buf);
	    }
	    return;
	}

	pass_ok = 0;	/* pass */
	for (i=1;i<12;i++) {
	    if (player[0][i].distance > 20) {
		pass_ok = 1;
		for (j=1;j<12;j++) { 
		    if (player[1][j].distance >= 0)  
			if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
					player[0][i].direction,player[1][j].direction) < 4 || 
			     (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
			      player[0][i].distance > player[1][j].distance)) &&
			    fabs(ch_dir(player[0][i].direction + abs_dir)) < 80)  

			    pass_ok = 0;
		}
	    }
	    if (pass_ok) break;
	}

	if (i<12) 
	    kick_cmd_d(buf,player[0][i].distance*2.6,player[0][i].direction,50040);
	else {
	    for (i = 11;i > 6;i--) {
		if (now_time - 4 < h_player[i].vdirection && 
		    fabs(ch_dir(h_player[i].direction + abs_dir)) < 60 && 
		    h_player[i].distance > 13 && h_player[i].distance < 34)
		    break;
	    }

	    if (i != 6) {
		kick_cmd_d(buf,h_player[i].distance * 2.6,h_player[i].direction,50055);
	    } else {
		o_dir = shoot_direction();
		kick_cmd_d(buf,100,o_dir,50050);
	    }
	}
    } else {
	for (i = 11;i > 6;i--) {
	    if (now_time - 3 < h_player[i].vdirection && 
		fabs(ch_dir(h_player[i].direction + abs_dir)) < 60 && 
		h_player[i].distance > 25 && h_player[i].distance < 34)
		break;
	}

	if (i != 6) {
	    kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
        } else {
	    if (rand() % 2 == 0) {
		o_dir = shoot_direction();
		kick_cmd_d(buf,100,o_dir,50060);
	    } else {
		through_pass(buf);
	    }
	}
    }
    kick_range_flg = 0;
}

void def_half_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis,me_goal_dis;
    int rnd_idx;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (now_time - 5 > h_now_time)
		turn_cmd_i(buf,80,30010);  /* looking for ball */
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */
		    o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    if (fabs(o_dir) < 22)
			turn_cmd_i(buf,80,30015);
		    else
			turn_cmd_d(buf,o_dir,30020);  /* looking for ball */
/*		} else {
		    turn_cmd_i(buf,80,30025);
		} */
	    }
	} else {
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		def_half_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 
		if (obj_x >5) { 
		    if (fabs(obj_x - 40 - my_x) > 10 || fabs(my_y) > 5) {
			o_dir = atan2(0 - my_y,obj_x - 40 - my_x)
			              * 180.0 / M_PI;
			o_dir = o_dir - abs_dir;
		    
			if (fabs(o_dir + abs_dir) >  171) {
			    dash_cmd_d(buf,-30,30084);
			    return;
			}

			if (fabs(o_dir) < T_RANGE) {
			    dash_cmd_d(buf,100,30085);
			    return;
			}
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;
			turn_cmd_d(buf,o_dir,30090); 
			status = 3;
		    } else {
			say_cmd_d(buf,30100);
		    }
		} else if (fabs(my_y) < 24 && my_x > -33) {
		    if (ball_estimate_flg == 0) {
			turn_cmd_d(buf,o_dir,30040);
			b_dis = o_dis;
			status = 2;
		    } else if (ball_estimate_flg = 1) { 
			if (player[0][t_num].direction < -T_RANGE || 
			    player[0][t_num].direction > T_RANGE) 
			    turn_cmd_d(buf,player[0][t_num].direction,30050); 
			else
			    dash_cmd_d(buf,player[0][t_num].distance*30,30060);
		    } else {
			dash_cmd_d(buf,player[0][t_num].distance*30,30080);
		    }
		} else {
		    if (fabs(my_y-init_position[t_num].y) > 3 ||
			fabs(my_x-init_position[t_num].x) > 3) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x)
			               * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
                    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;
			turn_cmd_d(buf,o_dir,30082); 
			status = 1;
		    } else {
			say_cmd_d(buf,30083);
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                def_half_kick(buf);
                status = 0;
                return;
        }
	if (time_idx[p_idx] < now_time - 15) {
		turn_cmd_d(buf,80,20155); 
		status = 0;
	        return;
        } 
	if (fabs(my_y-init_position[t_num].y) > 3 ||
	    fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,30110); 
	    else
                dash_cmd_d(buf,o_dis*30,30120);

	} else {
	    turn_cmd_d(buf,-abs_dir,30130);
	    status = 0;
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                def_half_kick(buf);
                status = 0;
                return;
        }
	if (b_dis > 6.666 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis*33,30140);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,30150);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                def_half_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,30170);
	status = 0;
    }
}

/*************************************************************
    Offensive - half manager
**************************************************************/
void off_half_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int	rnd_idx;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }
    rnd_idx = rand() % 6;
    if (rnd_idx < 5) {			/* goal clear */
	o_dir = atan2(obj_pojition[3][rnd_idx].y - my_y,obj_pojition[3][rnd_idx].x - my_x);
	o_dis = (obj_pojition[3][rnd_idx].x - my_x) / cos(o_dir);
	o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
    } else {
	o_dir = atan2(obj_pojition[4][2].y - my_y,obj_pojition[4][2].x - my_x);
	o_dis = (obj_pojition[4][2].x - my_x) / cos(o_dir);
	o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
    }
    if (o_dir < -180)  
	o_dir =  360 + o_dir;
    else 
	if (o_dir > 180)
	    o_dir = -360 + o_dir;

    kick_cmd_d(buf,o_dis * 2,o_dir,40030);
    kick_range_flg = 0;

}

void off_half_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis,me_goal_dis;
    int	rnd_idx;
    
    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (now_time - 5 > h_now_time)
		turn_cmd_i(buf,90,40010);  	/* looking for ball */
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */
		    o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    if (fabs(o_dir) < 44)
			turn_cmd_i(buf,80,40025);  /* looking for ball */
		    else
			turn_cmd_d(buf,o_dir,40020);  /* looking for ball */
/*		} else {
		    turn_cmd_i(buf,80,40025);  
		} */    
	    }
	} else {
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		off_half_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

		o_dis = sqrt((obj_x - obj_pojition[0][2].x) * (obj_x - obj_pojition[0][2].x) + 
                             (obj_y - obj_pojition[0][2].y) * (obj_y - obj_pojition[0][2].y));

		if (obj_x > -14)
		    if (player[0][t_num].distance < 15 ||
			(fabs(obj_x) < 2 && fabs(obj_y < 2))) {
			ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 
			if (ball_estimate_flg == 0) {
			    turn_cmd_d(buf,o_dir,40040);
			    b_dis = o_dis;
			    status = 2;
			} else if (ball_estimate_flg = 1) { 
			    if (player[0][t_num].direction < -T_RANGE || 
				player[0][t_num].direction > T_RANGE) 
				turn_cmd_d(buf,player[0][t_num].direction,40050); 
			    else    
				dash_cmd_d(buf,player[0][t_num].distance*30,40060); 
			} else {
			    dash_cmd_d(buf,player[0][t_num].distance*30,40080); 
			}
		    } else
			if (player[0][t_num].direction < -T_RANGE || 
			    player[0][t_num].direction > T_RANGE) 
			    turn_cmd_d(buf,player[0][t_num].direction,40090);
			else    
			    dash_cmd_d(buf,(player[0][t_num].distance-15.1) * 30,40100);
		else {
		    if (fabs(my_y-init_position[t_num].y) > 3 ||
			fabs(my_x-init_position[t_num].x) > 3) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x)
			              * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;

			turn_cmd_d(buf,o_dir,40110);
			status = 1;
		    } else {
			say_cmd_d(buf,40120);
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                off_half_kick(buf);
                status = 0;
                return;
        }
	if (fabs(my_y-init_position[t_num].y) > 3 ||
	    fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,40130); 
	    else
                dash_cmd_d(buf,o_dis*30,40140);
	} else {
	    turn_cmd_d(buf,-abs_dir,40150);
	    status = 0;
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                off_half_kick(buf);
                status = 0;
                return;
        }
	if (b_dis > 6.666 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis*33,40160);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,40170);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE)
	     || kick_range_flg) { /* kick renge */
                off_half_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,40190);
	status = 0;
    }
}

/*************************************************************
    MF-wing manager
**************************************************************/
void mfw_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }
    if (fabs(abs_dir) < 120) {
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && player[1][j].distance < 12)
		break;
        }
	if (j == 12) {		/* ɥ֥ */
	    if (t_num % 2) 	pass_ok = 1;
		else 		pass_ok = 3;

	    if (my_x < 38) {
		if (rand() % 9 != 0 || my_x < 28) {
		    if (t_num % 2) 	i = 0;
		    else 		i = 4;
		    if (spaceinfo[4][i].distance >= 0 && spaceinfo[4][i].distance < 25) {
			for (j=1;j<12;j++) 
			    if (player[1][j].distance >= 0)
				if (cos_theorem(spaceinfo[4][i].distance,player[1][j].distance,
						spaceinfo[4][i].direction,player[1][j].direction) < 12) 
				    break;
			if (j == 12) {
			    kick_cmd_d(buf,spaceinfo[4][i].distance*1.4,spaceinfo[4][i].direction,50036);
			    return;
			}
		    }
		    o_dir = atan2(obj_pojition[4][pass_ok].y - my_y,
				  obj_pojition[4][pass_ok].x - my_x)
			          * 180.0 / M_PI; 
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;

		    kick_cmd_d(buf,9+rand()%3,o_dir,50035);
		    d_dir = o_dir;
	       } else {
		   if (rand() % 2 != 0) {
		       through_pass(buf);
		   } else {
		       if (t_num % 2) 	pass_ok = 0;
		       else 		pass_ok = 4;
		       o_dir = atan2(obj_pojition[4][pass_ok].y - my_y,
				     obj_pojition[4][pass_ok].x - my_x);
		       o_dis = (obj_pojition[4][pass_ok].x - my_x) / cos(o_dir);
		       o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
		       if (o_dir < -180)  
			   o_dir =  360 + o_dir;
		       else 
			   if (o_dir > 180)
			       o_dir = -360 + o_dir;
		       kick_cmd_d(buf,o_dis*1.4,o_dir,50036);
		   }
	       }
	    } else {
		if (fabs(my_y) > 15) {
		    o_dir = atan2(0 - my_y,38  - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		} else {
		    o_dir = shoot_direction();
		}
                kick_cmd_d(buf,85,o_dir,50037);
	    }
	    return;
	}
	pass_ok = 0;
	for (i=1;i<12;i++) {
	    if (player[0][i].distance > 15) {
		pass_ok = 1;
		for (j=1;j<12;j++) { 
		    if (player[1][j].distance >= 0)  
			if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
					player[0][i].direction,player[1][j].direction) < 4 || 
			     (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
			      player[0][i].distance > player[1][j].distance)) &&
			    fabs(ch_dir(player[0][i].direction + abs_dir)) < 80) 

			    pass_ok = 0;
		}
	    }
	    if (pass_ok) break;
	}

	if (i<12) 
	    kick_cmd_d(buf,player[0][i].distance*3.1,player[0][i].direction,50040);
	else {
	    if (rand() % 4 == 0) {
		o_dir = shoot_direction();
		kick_cmd_d(buf,100,o_dir,50050);
	    } else {
		through_pass(buf);
	    }
	}
    } else {
	for (i = 11;i > 6;i--) {
	    if (now_time - 3 < h_player[i].vdirection && 
		fabs(ch_dir(h_player[i].direction + abs_dir)) < 70 && 
		h_player[i].distance > 13 && h_player[i].distance < 34)
		break;
	}

	if (i != 6) {
	    kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
        } else {
	    if (rand() % 2 == 0) {
		o_dir = shoot_direction();
		kick_cmd_d(buf,100,o_dir,50060);
	    } else {
		if (rand() % 2 != 0) {
		    through_pass(buf);
		} else {
		    if (t_num % 2) 	pass_ok = 0;
		    else 		pass_ok = 4;
		    o_dir = atan2(obj_pojition[4][pass_ok].y - my_y,
				  obj_pojition[4][pass_ok].x - my_x);
		    o_dis = (obj_pojition[4][pass_ok].x - my_x) / cos(o_dir);
		    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    kick_cmd_d(buf,o_dis*1.4,o_dir,50036);
		}
	    }
	}
    }

    kick_range_flg = 0;
}


void mfw_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (d_dir != 0) {
		turn_cmd_d(buf,d_dir,50010);  /* looking for ball */
		d_dir = 0;
		return;
            }

	    if (now_time - 5 > h_now_time)
		turn_cmd_i(buf,near_ball(),50010);  /* looking for ball */
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */

		    if (h_b_x > -30 && !(((t_num % 2) == 0 && h_b_y > 5) || ((t_num % 2) == 1 && h_b_y < -5)) && 
			fabs(h_b_y - my_x - 2) > 5) {
                            o_dir = atan2(init_position[t_num].y - my_y,h_b_x - my_x - 2) * 180.0 / M_PI;
                            o_dir = o_dir - abs_dir;
                    
                            if (fabs(o_dir) < T_RANGE) {
                                dash_cmd_d(buf,100,50120);
                                return;
                            }
                            if (o_dir < -180)  
                                o_dir =  360 + o_dir;
                            else 
                                if (o_dir > 180)
                                    o_dir = -360 + o_dir;
  			    turn_cmd_d(buf,o_dir,50130); 
			    status = 3;
		    } else {
			o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
			o_dir = o_dir - abs_dir;
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
			    o_dir = -360 + o_dir;
			if (fabs(o_dir) < 22)
	   		    turn_cmd_i(buf,near_ball(),50015);  /* looking for ball */
			else
			    turn_cmd_d(buf,o_dir,50020);  /* looking for ball */
		    }
/*		} else {
		    turn_cmd_i(buf,near_ball(),50030);  
		} */
	    }
	} else {
	    d_dir = 0;
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		mfw_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

/* 		o_dis = sqrt((obj_x - obj_pojition[0][2].x) * (obj_x - obj_pojition[0][2].x) + 
                             (obj_y - obj_pojition[0][2].y) * (obj_y - obj_pojition[0][2].y)); */

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 
		if (obj_x > -30) {
		    if (((t_num % 2) == 0 && obj_y > 5) || ((t_num % 2) == 1 && obj_y < -5)) {
			if (ball_estimate_flg == 0) {
			    turn_cmd_d(buf,o_dir,50070);
			    b_dis = o_dis;
			    status = 2;
			} else if (ball_estimate_flg = 1) { 
			    if (player[0][t_num].direction < -T_RANGE || 
				player[0][t_num].direction > T_RANGE) 
				turn_cmd_d(buf,player[0][t_num].direction,50080); 
			    else    
				dash_cmd_d(buf,player[0][t_num].distance*30,50090); 
			} else {
				dash_cmd_d(buf,player[0][t_num].distance*30,50110); 
			}
		    } else {
			/* 褯ʬʤ */
			if (fabs(obj_x - my_x - 2) > 5) {
                            o_dir = atan2(init_position[t_num].y - my_y,obj_x - my_x - 2) * 180.0 / M_PI;
                            o_dir = o_dir - abs_dir;
                    
                            if (fabs(o_dir) < T_RANGE) {
                                dash_cmd_d(buf,100,50120);
                                return;
                            }
                            if (o_dir < -180)  
                                o_dir =  360 + o_dir;
                            else 
                                if (o_dir > 180)
                                    o_dir = -360 + o_dir;
  			    turn_cmd_d(buf,o_dir,50130); 
			    status = 3;
                        } else {
			    say_cmd_d(buf,50140);
			}
		    }
		} else {
		    if (fabs(my_y-init_position[t_num].y) > 3 ||
			fabs(my_x-init_position[t_num].x) > 3) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x)
			              * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;

			turn_cmd_d(buf,o_dir,50150);
			status = 1;
		    } else {
			say_cmd_d(buf,50160);
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                mfw_kick(buf);
                status = 0;
                return;
        }
	if (time_idx[p_idx] < now_time - 15) {
		turn_cmd_d(buf,180,20155); 
		status = 0;
	        return;
        } 
	if (fabs(my_y-init_position[t_num].y) > 3 || fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,50170); 
	    else
                dash_cmd_d(buf,o_dis*30,50180);

	} else {
	    turn_cmd_d(buf,-abs_dir,50190);
	    status = 0;
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                mfw_kick(buf);
                status = 0;
                return;
        }
        if (b_dis > 6.666 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis*33,50200);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,50210);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                mfw_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,50230);
	status = 0;
    }
}

/*************************************************************
    FW manager
**************************************************************/
void fw_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;
    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }
    if (fabs(abs_dir) < 120) {
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && player[1][j].distance < 12)
		break;
        }
	if (j == 12) {		/* ɥ֥ */
	    if (fabs(my_y) < 20) pass_ok = 2; 
		else if (t_num % 2)  pass_ok = 1;
		else 		     pass_ok = 3;

	    if (my_x < 36) {
		o_dir = atan2(obj_pojition[4][pass_ok].y - my_y,
			      obj_pojition[4][pass_ok].x - my_x)
	                      * 180.0 / M_PI; 
		o_dir = o_dir - abs_dir;
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		kick_cmd_d(buf,9,o_dir,50035);
		d_dir = o_dir;
	    } else {
		if (fabs(my_y) > 22) { 
		    o_dir = atan2(0 - my_y,38 - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    kick_cmd_d(buf,85,o_dir,50037);
		} else {
		    kick_cmd_d(buf,100,shoot_direction(),50037);
		}
	    }
	    kick_range_flg = 0;
	    return;
	}
	    if (my_x > 35 && fabs(my_y) < 22) {
		kick_cmd_d(buf,100,shoot_direction(),50037);
		kick_range_flg = 0;
		return ;
	    }

	    pass_ok = 0;
	    for (i=1;i<12;i++) {
		if (player[0][i].distance > 15) {
		    pass_ok = 1;
		    for (j=1;j<12;j++) { 
			if (player[1][j].distance >= 0)  
			    if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
					    player[0][i].direction,player[1][j].direction) < 4 ||
				 (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
				  player[0][i].distance > player[1][j].distance )) &&
				fabs(ch_dir(player[0][i].direction + abs_dir)) < 80) 

				pass_ok = 0;
		    }
		}
		if (pass_ok) break;
	    }

	    if (i<12) 
		kick_cmd_d(buf,player[0][i].distance*2.7,player[0][i].direction,50040);
	    else {
		if (fabs(my_x) > 32 && fabs(my_y) < 20)
		    kick_cmd_d(buf,100,shoot_direction(),50050);
		else
		    through_pass(buf);
	    }
    } else {
	if (my_x < 33) {
	    for (i = 11;i > 9;i--) {
		if (now_time - 3 < h_player[i].vdirection && 
		    fabs(ch_dir(h_player[i].direction + abs_dir)) < 120 && 
		    h_player[i].distance > 10)
		    break;
	    }
	    if (i != 9) 
		kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
	    else {
		if (my_y > 0) 	i = 22;
		else		i = -22;  
		o_dir = atan2(i - my_y,- 3);
		o_dis = (- 3) / cos(o_dir);
		o_dir = (o_dir * 180.0 / M_PI) - abs_dir;   
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;
		kick_cmd_d(buf,o_dis*2.1,o_dir,50056);
	    }
	} else
	    kick_cmd_d(buf,100,shoot_direction(),50060);
    }

    kick_range_flg = 0;
}

void fw_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (d_dir != 0) {
		turn_cmd_d(buf,d_dir,60005);  /* looking for ball */
		d_dir = 0;
		return;
            }
	    if (now_time - 3 > h_now_time)
		turn_cmd_i(buf,near_ball(),60010);  /* looking for ball */
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */

		    if (h_b_x > 16 && !(((t_num % 2) == 0 && h_b_y > -3) || ((t_num % 2) == 1 && h_b_y < 3))) {
			if (fabs(h_b_y) > 15 && h_b_x > 28 && (fabs(43 - my_x) > 3 || fabs(0 - my_y) > 3)) { 
			    o_dir = atan2(0 - my_y,43 - my_x) * 180.0 / M_PI;
			    o_dir = o_dir - abs_dir;
                    
			    if (fabs(o_dir) < T_RANGE) {
				dash_cmd_d(buf,100,30085);
				return;
			    }
			    if (o_dir < -180)  
				o_dir =  360 + o_dir;
			    else 
				if (o_dir > 180)
				    o_dir = -360 + o_dir;
			    turn_cmd_d(buf,o_dir,30090); 
			    status = 3;
/*			} else if (fabs(h_b_x + 10 - my_x) > 5) {
			    o_dir = atan2(0 - my_y,h_b_x + 10 - my_x)
				          * 180.0 / M_PI;
			    o_dir = o_dir - abs_dir;
                    
			    if (fabs(o_dir) < T_RANGE) {
				dash_cmd_d(buf,100,30085);
				return;
			    }
			    if (o_dir < -180)  
				o_dir =  360 + o_dir;
			    else 
				if (o_dir > 180)
				    o_dir = -360 + o_dir;
			    turn_cmd_d(buf,o_dir,30090); 
			    status = 3; */
			} else {
			    o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
			    o_dir = o_dir - abs_dir;
			    if (o_dir < -180)  
				o_dir =  360 + o_dir;
			    else 
				if (o_dir > 180)
				    o_dir = -360 + o_dir;
			    if (fabs(o_dir) < 22)
				turn_cmd_i(buf,near_ball(),50015);  /* looking for ball */
			    else
				turn_cmd_d(buf,o_dir,50020);  /* looking for ball */

			}
		    } else {
			o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
			o_dir = o_dir - abs_dir;
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;
			if (fabs(o_dir) < 22)
			    turn_cmd_i(buf,near_ball(),50015);  /* looking for ball */
			else
			    turn_cmd_d(buf,o_dir,50020);  /* looking for ball */
		    }
/*		} else {
		    turn_cmd_i(buf,near_ball(),50030);  
		} */
	    }
	} else {
	    d_dir = 0;
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		fw_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

/* 		o_dis = sqrt((obj_x - obj_pojition[0][2].x) * (obj_x - obj_pojition[0][2].x) + 
                             (obj_y - obj_pojition[0][2].y) * (obj_y - obj_pojition[0][2].y)); */


		for (i=1;i<12;i++) {
		    if (player[0][i].distance >= 0 && (i!=t_num) &&
		        cos_theorem(player[0][t_num].distance ,player[0][i].distance,
				    player[0][t_num].direction,player[0][i].direction) < 4)
			break;
		}    

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 

		if (obj_x > 12) {
		    if ((((t_num % 2) == 0 && obj_y > -3) || ((t_num % 2) == 1 && obj_y < 3)) && i == 12) {
			if (ball_estimate_flg == 0) {
			    turn_cmd_d(buf,o_dir,50070);
			    b_dis = o_dis;
			    status = 2;
			} else if (ball_estimate_flg = 1) { 
			    if (player[0][t_num].direction < -T_RANGE || 
				player[0][t_num].direction > T_RANGE) 
				turn_cmd_d(buf,player[0][t_num].direction,50080); 
			    else    
				dash_cmd_d(buf,player[0][t_num].distance*30,50090); 
			} else {
			    dash_cmd_d(buf,player[0][t_num].distance*30,50110); 
			}
		    } else {
			/* 褯ʬʤ */
			if (fabs(obj_y) > 15 && obj_x > 28) {
			    if (fabs(43 - my_x) > 3 || fabs(0 - my_y) > 3) { 
				o_dir = atan2(0 - my_y,43 - my_x) * 180.0 / M_PI;
				o_dir = o_dir - abs_dir;
                    
				if (fabs(o_dir) < T_RANGE) {
				    dash_cmd_d(buf,100,30085);
				    return;
				}
				if (o_dir < -180)  
				    o_dir =  360 + o_dir;
				else 
				    if (o_dir > 180)
					o_dir = -360 + o_dir;
				turn_cmd_d(buf,o_dir,30090); 
				status = 3;
			    } else { 
				say_cmd_d(buf,30100);
			    }
			} else if (fabs(obj_x + 10 - my_x) > 5 && obj_x < 35) {
			    o_dir = atan2(0 - my_y,obj_x + 10 - my_x)
				          * 180.0 / M_PI;
			    o_dir = o_dir - abs_dir;
                    
			    if (fabs(o_dir) < T_RANGE) {
				dash_cmd_d(buf,100,30085);
				return;
			    }
			    if (o_dir < -180)  
				o_dir =  360 + o_dir;
			    else 
				if (o_dir > 180)
				    o_dir = -360 + o_dir;
			    turn_cmd_d(buf,o_dir,30090); 
			    status = 3;
			} else {
			    say_cmd_d(buf,30100);
			}
		    }
		} else {
		    if (fabs(my_y-init_position[t_num].y) > 5 ||
			fabs(my_x - 20) > 5) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x+20)
			              * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;

			turn_cmd_d(buf,o_dir,50150);
			status = 1;
		    } else {
			say_cmd_d(buf,50160);
		    }
		}
	    } 
	}
    } else if (status == 1) {
	if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
	    kick_range_flg) { /* kick renge */
		fw_kick(buf);
		status = 0;
                return;
	}
	if (time_idx[p_idx] < now_time - 15) {
		turn_cmd_d(buf,180,20155); 
		status = 0;
	        return;
        } 
	if (fabs(my_y-init_position[t_num].y) > 5 ||
	    fabs(my_x-20) > 5) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x+20);

	    o_dis = (init_position[t_num].x - my_x+20) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,50170); 
	    else
                dash_cmd_d(buf,o_dis*30,50180);

	} else {
	    turn_cmd_d(buf,-abs_dir,50190);
	    status = 0;
        }
    } else if (status == 2) {
	if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
	    kick_range_flg) { /* kick renge */
		fw_kick(buf);
		status = 0;
                return;
	}
        if (b_dis > 6.666 || b_dis < 3.333) {
            dash_cmd_d(buf,b_dis*33,30140);
            status = 0;
        } else {
            dash_cmd_d(buf,100,30150);
            b_dis = b_dis - 3.4;
        }
    } else {
	if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
	    kick_range_flg) { /* kick renge */
		fw_kick(buf);
		status = 0;
                return;
	}
	dash_cmd_d(buf,100,50230);
	status = 0;
    }
}

/*************************************************************
    df-sideback manager
**************************************************************/
void dfb_kick(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (kick_flg && (rand() % 2)) {
	kick_cmd_d(buf,100,shoot_direction(),90000);
	return;
    }

    if (fabs(abs_dir) < 120) {
	for (j=1;j<12;j++) {
	    if (player[1][j].distance >= 0 && player[1][j].distance < 7)
		break;
        }
	if (j == 12 && my_x > 0) {		/* ɥ֥ */
	    if (t_num % 2) 	pass_ok = 1;
		else 		pass_ok = 3;

	    if (my_x < 38) {
		o_dir = atan2(obj_pojition[4][pass_ok].y - my_y,
			      obj_pojition[4][pass_ok].x - my_x)
			      * 180.0 / M_PI; 
		o_dir = o_dir - abs_dir;
		if (o_dir < -180)  
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		kick_cmd_d(buf,9,o_dir,50035);
                d_dir = o_dir;
	    } else {
		if (fabs(my_y) > 15) {
		    o_dir = atan2(0 - my_y,40  - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		} else {
		    o_dir = shoot_direction();
		}
                kick_cmd_d(buf,100,o_dir,50037);
	    }
	    return;
	}
	pass_ok = 0;
	for (i=1;i<12;i++) {
	    if (player[0][i].distance > 20) {
		pass_ok = 1;
		for (j=1;j<12;j++) { 
		    if (player[1][j].distance >= 0)  
			if ((cos_theorem(player[0][i].distance ,player[1][j].distance,
					player[0][i].direction,player[1][j].direction) < 4 || 
			     (fabs(player[0][i].direction - player[1][j].direction) < 4 &&
			      player[0][i].distance > player[1][j].distance)) &&
			    fabs(ch_dir(player[0][i].direction + abs_dir)) < 80) 

			    pass_ok = 0;
		}
	    }
	    if (pass_ok) break;
	}

	if (i<12) 
	    kick_cmd_d(buf,player[0][i].distance*3.1,player[0][i].direction,50040);
	else {
	    for (i = 11;i > 6;i--) {
		if (now_time - 3 < h_player[i].vdirection && 
		    fabs(ch_dir(h_player[i].direction + abs_dir)) < 60 &&
		    h_player[i].distance > 22 && h_player[i].distance < 34)
		    break;
	    }

	    if (i != 6) {
		kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
	    } else {
		o_dir = shoot_direction();
		kick_cmd_d(buf,100,o_dir,50050);
	    }
	}
    } else {
	for (i = 11;i > 6;i--) {
	    if (now_time - 3 < h_player[i].vdirection && 
		fabs(ch_dir(h_player[i].direction + abs_dir)) < 60 &&
		h_player[i].distance > 22 && h_player[i].distance < 34)
		break;
	}

	if (i != 6) {
	    kick_cmd_d(buf,h_player[i].distance * 3.1,h_player[i].direction,50055);
        } else {
	    o_dir = shoot_direction();
	    kick_cmd_d(buf,100,o_dir,50060);
	}
    }

    kick_range_flg = 0;
}



void dfb_manager(char *buf)
{
    double  o_dir,obj_x,obj_y,o_dis;
    int pass_ok,i,j,o_dir_i;

    if (status == 0) {
        if (player[0][t_num].distance < 0 && kick_range_flg == 0) { /* lost ball info */
	    if (d_dir != 0) {
		turn_cmd_d(buf,d_dir,50010);  /* looking for ball */
		d_dir = 0;
		return;
            }

	    if (now_time - 3 > h_now_time)
		turn_cmd_i(buf,near_ball(),50010);  /* looking for ball */
	    else {
/*		if (my_p_know == 0 &&
		    (fabs(h_b_y - my_y) > 1.3 || fabs(h_b_x - my_x) > 1.3)) { */
		    o_dir = atan2(h_b_y - my_y,h_b_x - my_x) * 180.0 / M_PI;
		    o_dir = o_dir - abs_dir;
		    if (o_dir < -180)  
			o_dir =  360 + o_dir;
		    else 
			if (o_dir > 180)
			    o_dir = -360 + o_dir;
		    if (fabs(o_dir) < 22)
			turn_cmd_i(buf,near_ball(),50015);  /* looking for ball */
		    else
			turn_cmd_d(buf,o_dir,50020);  /* looking for ball */
/*		} else {
		    turn_cmd_i(buf,near_ball(),50030);  
		} */
	    }
	} else {
	    d_dir = 0;
	    if (player[0][t_num].distance < K_RANGE || kick_range_flg) { /* kick renge */
		dfb_kick(buf);
	    } else {		/* turn or dash */
		o_dir  = player[0][t_num].direction + abs_dir;
		if (o_dir < -180)
		    o_dir =  360 + o_dir;
		else 
		    if (o_dir > 180)
			o_dir = -360 + o_dir;

		obj_x = my_x + player[0][t_num].distance * cos(o_dir  / 180.0 * M_PI);
		obj_y = my_y + player[0][t_num].distance * sin(o_dir  / 180.0 * M_PI);

/* 		o_dis = sqrt((obj_x - obj_pojition[0][2].x) * (obj_x - obj_pojition[0][2].x) + 
                             (obj_y - obj_pojition[0][2].y) * (obj_y - obj_pojition[0][2].y)); */

		ball_estimate_flg = ball_estimate(&o_dis,&o_dir,&obj_x,&obj_y); 


		if (obj_x >= 15) {
		    if (fabs(-20 - my_x) > 5) {
			o_dir = atan2(init_position[t_num].y - my_y,- 20 - my_x)  * 180.0 / M_PI;
			o_dir = o_dir - abs_dir;
                    
			if (fabs(o_dir) < T_RANGE) {
			    dash_cmd_d(buf,100,50120);
			    return;
			}
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;
			turn_cmd_d(buf,o_dir,50130); 
			status = 3;
		    } else {
			say_cmd_d(buf,50140);
		    }	
		} else if (obj_x < -30 || obj_x > -12) {
		    if (((t_num % 2) == 0 && obj_y > 5) || ((t_num % 2) == 1 && obj_y < -5)) {
			if (ball_estimate_flg == 0) {
			    turn_cmd_d(buf,o_dir,50070);
			    b_dis = o_dis;
			    status = 2;
			} else if (ball_estimate_flg = 1) { 
			    if (player[0][t_num].direction < -T_RANGE || 
				player[0][t_num].direction > T_RANGE) 
				turn_cmd_d(buf,player[0][t_num].direction,50080); 
			    else    
				dash_cmd_d(buf,player[0][t_num].distance*30,50090); 
			} else {
			    dash_cmd_d(buf,player[0][t_num].distance*30,50110); 
			}
		    } else {
			/* 褯ʬʤ */
			if (fabs(obj_x - my_x - 3) > 5) {
                            o_dir = atan2(init_position[t_num].y - my_y,obj_x - my_x - 3) * 180.0 / M_PI;
                            o_dir = o_dir - abs_dir;
                    
                            if (fabs(o_dir) < T_RANGE) {
                                dash_cmd_d(buf,100,50120);
                                return;
                            }
                            if (o_dir < -180)  
                                o_dir =  360 + o_dir;
                            else 
                                if (o_dir > 180)
                                    o_dir = -360 + o_dir;
  			    turn_cmd_d(buf,o_dir,50130); 
			    status = 3;
                        } else {
			    say_cmd_d(buf,50140);
			}
		    }
		} else {
		    if (fabs(my_y-init_position[t_num].y) > 3 ||
			fabs(my_x-init_position[t_num].x) > 3) {
			o_dir = atan2(init_position[t_num].y - my_y,
				      init_position[t_num].x - my_x)
			              * 180.0 / M_PI; 
			o_dir = o_dir - abs_dir;
		    
			if (o_dir < -180)  
			    o_dir =  360 + o_dir;
			else 
			    if (o_dir > 180)
				o_dir = -360 + o_dir;

			turn_cmd_d(buf,o_dir,50150);
			status = 1;
		    } else {
			say_cmd_d(buf,50160);
		    }
		}
	    } 
	}
    } else if (status == 1) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                dfb_kick(buf);
                status = 0;
                return;
        }
	if (time_idx[p_idx] < now_time - 15) {
		turn_cmd_d(buf,180,20155); 
		status = 0;
	        return;
        } 
	if (fabs(my_y-init_position[t_num].y) > 3 || fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);

	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);

	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,50170); 
	    else
                dash_cmd_d(buf,o_dis*30,50180);

	} else {
	    turn_cmd_d(buf,-abs_dir,50190);
	    status = 0;
        }
    } else if (status == 2) {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                dfb_kick(buf);
                status = 0;
                return;
        }
        if (b_dis > 6.666 || b_dis < 3.333) {
	    dash_cmd_d(buf,b_dis*33,50200);
	    status = 0;
	} else {
	    dash_cmd_d(buf,100,50210);
	    b_dis = b_dis - 3.4;
	}
    } else {
        if ((player[0][t_num].distance >= 0 && player[0][t_num].distance < K_RANGE) || 
            kick_range_flg) { /* kick renge */
                dfb_kick(buf);
                status = 0;
                return;
        }
	dash_cmd_d(buf,100,50230);
	status = 0;
    }
}

void send_manager(char *buf)
{

    double  o_dir,obj_x,obj_y,o_dis;
    int x,y;

    if (init_flag) {
	if (t_num)
	    sprintf (buf,"(reconnect %s %d)\n",t_name,t_num);
	else
	    sprintf (buf,"(init %s)\n",t_name);

	init_flag = ~init_flag;
	waitrecv = 1;
	return;
    }


    switch (game_sta) {
    case -2:			/* no send message */
	*buf = '\0';            
	break;
    case -1:			/* move command */
	sprintf (buf,"(move %d %d)\n",
		 init_position[t_num].x,
		 init_position[t_num].y);
	game_sta = -2;
	break;
    case 0:
	strcpy(buf,sendbuf);
	game_sta = -1;
	break;
    case 1:
	if (my_p_know == 3) {	/* line info lost (Server Ver. 2.84) */
	    sprintf (buf,"(turn 160)\n");
	    waitrecv = 1;
	    return;
	}

	switch (t_num)  {
	case 1:
	    gk_manager(buf);
	    break;
        case 6:
	    def_half_manager(buf);
	    break;
        case 9:
	    off_half_manager(buf);
	    break;
        case 2:
        case 3:
	    dfs_manager(buf);
	    break;
        case 7:
        case 8:
	    mfw_manager(buf);
	    break;
        case 10:
        case 11:
	    fw_manager(buf);
	    break;
        case 4:
        case 5:
	    dfb_manager(buf);
	    break;
        }
	break;
    case 2:
	if (fabs(my_y-init_position[t_num].y) > 3 || 
	    fabs(my_x-init_position[t_num].x) > 3) {
	    o_dir = atan2(init_position[t_num].y - my_y,
			  init_position[t_num].x - my_x);
	    o_dis = (init_position[t_num].x - my_x) / cos(o_dir);
	    o_dir = (o_dir * 180.0 / M_PI) - abs_dir;
	   
	    if (o_dir < -180)  
		o_dir =  360 + o_dir;
	    else 
		if (o_dir > 180)
		    o_dir = -360 + o_dir;
	    
	    if (o_dir < -T_RANGE || o_dir > T_RANGE)   
		turn_cmd_d(buf,o_dir,100170); 
	    else
		dash_cmd_d(buf,o_dis*30,100180);
	} else {
	    turn_cmd_d(buf,-abs_dir,50190);
	    game_sta = -2;
	}
        break;
    }
    waitrecv = 1;
}



